"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SkeletonView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeLinearGradient = _interopRequireDefault(require("react-native-linear-gradient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const {
  width
} = _reactNative.Dimensions.get('window');

const SkeletonView = _ref => {
  let {
    style,
    backgroundColor = '#E2E9ED',
    duration = 1000,
    highlightColor
  } = _ref;

  const Styles = _reactNative.StyleSheet.create({
    DefaultStyle: {
      overflow: 'hidden',
      backgroundColor: backgroundColor
    }
  });

  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [style, Styles.DefaultStyle]
  }, /*#__PURE__*/_react.default.createElement(SkeletonAnimation, {
    duration: duration,
    highlightColor: highlightColor,
    backgroundColor: backgroundColor
  }));
};

exports.SkeletonView = SkeletonView;

const SkeletonAnimation = _ref2 => {
  let {
    backgroundColor = '#E2E9ED',
    highlightColor = '#D9E0E3',
    duration = 1000
  } = _ref2;
  const animatedValue = new _reactNative.Animated.Value(0);
  (0, _react.useEffect)(() => {
    _reactNative.Animated.loop(_reactNative.Animated.timing(animatedValue, {
      toValue: 1,
      duration: duration,
      easing: _reactNative.Easing.linear,
      useNativeDriver: true
    })).start();
  });
  const translateX = animatedValue.interpolate({
    inputRange: [0, 1],
    outputRange: [-width, width]
  });
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.Wrapper
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    style: [styles.DefaultSize, {
      transform: [{
        translateX: translateX
      }]
    }]
  }, /*#__PURE__*/_react.default.createElement(_reactNativeLinearGradient.default, {
    colors: [backgroundColor, highlightColor, highlightColor, backgroundColor],
    style: styles.DefaultSize,
    start: {
      x: 0,
      y: 0
    },
    end: {
      x: 1,
      y: 0
    }
  })));
};

const styles = _reactNative.StyleSheet.create({
  Wrapper: {
    width: '100%',
    height: '100%'
  },
  DefaultSize: {
    width: '100%',
    height: '100%'
  }
});
//# sourceMappingURL=SkeletonView.js.map